/*************************************************************************************************************
*
* Title			    : Example HTP DMX Muxer for Arduino DMX512 library. 
* Version		    : v0.1
* Last updated	            : 29.04.2012
* Target		    : Arduino mega 2560, Arduino mega 1280
* Author                    : Toni Merino - merino.toni at gmail.com
* Web                       : www.deskontrol.es
*
**************************************************************************************************************/
#include <lib_dmx.h>  // comment/uncomment #define USE_UARTx in lib_dmx.h as needed

// This sample get 512 channels from universe 1 + 512 channels from universe 2, 
// and write the highgest value to universe 3

void setup() 
{
  //ArduinoDmx0.set_control_pin(22);      //max485 input/output control (connect to 485 pins 2-3) 
  ArduinoDmx1.set_control_pin(24);
  ArduinoDmx2.set_control_pin(26);
  ArduinoDmx3.set_control_pin(28);
  
  //ArduinoDmx0.set_rx_led_pin(30);      //rx signal indicator led pin, don't care
  ArduinoDmx1.set_rx_led_pin(13); //31
  ArduinoDmx2.set_rx_led_pin(32);
  ArduinoDmx3.set_rx_led_pin(33);
  
  //ArduinoDmx0.set_tx_led_pin(34);      //tx signal indicator led pin, don't care
  ArduinoDmx1.set_tx_led_pin(35);
  ArduinoDmx2.set_tx_led_pin(36);
  ArduinoDmx3.set_tx_led_pin(37);
  
  cli();          //disable interrupts
  
  ArduinoDmx1.set_rx_address(1);    //set rx1 start address
  ArduinoDmx2.set_rx_address(1);    //set rx2 start address
  ArduinoDmx3.set_tx_address(1);    //set tx start address
  
  ArduinoDmx1.set_rx_channels(512);
  ArduinoDmx2.set_rx_channels(512);
  ArduinoDmx3.set_tx_channels(512);
  
  ArduinoDmx1.init_rx();    //starts universe 1 as rx
  ArduinoDmx2.init_rx();    //starts universe 2 as rx
  ArduinoDmx3.init_tx();    //starts universe 3 as tx
  
  sei();          //enable interrupts
}  //end setup()

void loop()
{
  int i;
  for(;;)
  {
    for(i=0;i<512;i++)  //buffers 0 indexed (0-511)
    {
      // copy values from input buffers to output buffer
      // High value take priority ( HTP )
      if(ArduinoDmx1.RxBuffer[i] > ArduinoDmx2.RxBuffer[i])
        ArduinoDmx3.TxBuffer[i] = ArduinoDmx1.RxBuffer[i];    
      else
        ArduinoDmx3.TxBuffer[i] = ArduinoDmx2.RxBuffer[i];
    }
  }
}  //end loop()

