/*************************************************************************************************************
*
* Title			    : Example DMX Receiver
* Version		    : v0.1
* Last updated	            : 29.04.2012
* Target		    : Arduino mega 2560, Arduino mega 1280, Arduino nano
* Author                    : Toni Merino - merino.toni at gmail.com
* Web                       : www.deskontrol.es
*
**************************************************************************************************************/
#include <lib_dmx.h>  // comment/uncomment #define USE_UARTx in lib_dmx.h as needed

void setup() 
{
  ArduinoDmx0.set_control_pin(22);      //max485 input/output control (connect to 485 pins 2-3) 
  //ArduinoDmx1.set_control_pin(24);
  //ArduinoDmx2.set_control_pin(26);
  //ArduinoDmx3.set_control_pin(28);
  
  ArduinoDmx0.set_rx_led_pin(13); //30     //rx signal indicator led pin, don't care
  //ArduinoDmx1.set_rx_led_pin(31);  
  //ArduinoDmx2.set_rx_led_pin(32);
  //ArduinoDmx3.set_rx_led_pin(33);
  
  //ArduinoDmx0.set_tx_led_pin(34);      //tx signal indicator led pin, don't care
  //ArduinoDmx1.set_tx_led_pin(35);
  //ArduinoDmx2.set_tx_led_pin(36);
  //ArduinoDmx3.set_tx_led_pin(37);
  
  cli();          //disable interrupts
  
  ArduinoDmx0.set_rx_address(1);      //set rx0 dmx start address
  ArduinoDmx0.set_rx_channels(4);     //number of rx channels
  ArduinoDmx0.init_rx();              //starts universe 0 as rx
  
  sei();          //enable interrupts
}  //end setup()

void loop()
{
  for(;;)
  {
    //write values from dmx channels 1-4 universe 0 to arduino pwm pins 2-5
    analogWrite(2, ArduinoDmx0.RxBuffer[0]);  //buffers 0 indexed
    analogWrite(3, ArduinoDmx0.RxBuffer[1]);
    analogWrite(4, ArduinoDmx0.RxBuffer[2]);
    analogWrite(5, ArduinoDmx0.RxBuffer[3]);
  }
}  //end loop()

